chapter \<open>Generated by Lem from \<open>list.lem\<close>.\<close>

theory "Lem_list" 

imports
  Main
  "Lem_bool"
  "Lem_maybe"
  "Lem_basic_classes"
  "Lem_function"
  "Lem_tuple"
  "Lem_num"
  "Lem"

begin 

 

\<comment> \<open>\<open>open import Bool Maybe Basic_classes Function Tuple Num\<close>\<close>

\<comment> \<open>\<open>open import {coq} `Coq.Lists.List`\<close>\<close>
\<comment> \<open>\<open>open import {isabelle} `$LIB_DIR/Lem`\<close>\<close>
\<comment> \<open>\<open>open import {hol} `lemTheory` `listTheory` `rich_listTheory` `sortingTheory`\<close>\<close>

\<comment> \<open>\<open> ========================================================================== \<close>\<close>
\<comment> \<open>\<open> Basic list functions                                                       \<close>\<close>
\<comment> \<open>\<open> ========================================================================== \<close>\<close>

\<comment> \<open>\<open> The type of lists as well as list literals like [], [1;2], ... are hardcoded. 
   Thus, we can directly dive into derived definitions. \<close>\<close>


\<comment> \<open>\<open> ----------------------- \<close>\<close>
\<comment> \<open>\<open> cons                    \<close>\<close>
\<comment> \<open>\<open> ----------------------- \<close>\<close>

\<comment> \<open>\<open>val :: : forall 'a. 'a -> list 'a -> list 'a\<close>\<close>


\<comment> \<open>\<open> ----------------------- \<close>\<close>
\<comment> \<open>\<open> Emptyness check         \<close>\<close>
\<comment> \<open>\<open> ----------------------- \<close>\<close>

\<comment> \<open>\<open>val null : forall 'a. list 'a -> bool\<close>\<close>
\<comment> \<open>\<open>let null l=  match l with [] -> true | _ -> false end\<close>\<close>

\<comment> \<open>\<open> ----------------------- \<close>\<close>
\<comment> \<open>\<open> Length                  \<close>\<close>
\<comment> \<open>\<open> ----------------------- \<close>\<close>

\<comment> \<open>\<open>val length : forall 'a. list 'a -> nat\<close>\<close>
\<comment> \<open>\<open>let rec length l=
   match l with
    | [] -> 0
    | x :: xs -> (Instance_Num_NumAdd_nat.+) (length xs) 1
  end\<close>\<close>

\<comment> \<open>\<open> ----------------------- \<close>\<close>
\<comment> \<open>\<open> Equality                \<close>\<close>
\<comment> \<open>\<open> ----------------------- \<close>\<close>

\<comment> \<open>\<open>val listEqual : forall 'a. Eq 'a => list 'a -> list 'a -> bool\<close>\<close>
\<comment> \<open>\<open>val listEqualBy : forall 'a. ('a -> 'a -> bool) -> list 'a -> list 'a -> bool\<close>\<close>

fun  listEqualBy  :: \<open>('a \<Rightarrow> 'a \<Rightarrow> bool)\<Rightarrow> 'a list \<Rightarrow> 'a list \<Rightarrow> bool \<close>  where 
     \<open> listEqualBy eq ([]) ([]) = ( True )\<close> 
  for  "eq"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool "
|\<open> listEqualBy eq ([]) (_ # _) = ( False )\<close> 
  for  "eq"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool "
|\<open> listEqualBy eq (_ # _) ([]) = ( False )\<close> 
  for  "eq"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool "
|\<open> listEqualBy eq (x # xs) (y # ys) = ( (eq x y \<and> listEqualBy eq xs ys))\<close> 
  for  "eq"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool " 
  and  "xs"  :: " 'a list " 
  and  "x"  :: " 'a " 
  and  "ys"  :: " 'a list " 
  and  "y"  :: " 'a "



\<comment> \<open>\<open> ----------------------- \<close>\<close>
\<comment> \<open>\<open> compare                 \<close>\<close>
\<comment> \<open>\<open> ----------------------- \<close>\<close>

\<comment> \<open>\<open>val lexicographicCompare : forall 'a. Ord 'a => list 'a -> list 'a -> ordering\<close>\<close>
\<comment> \<open>\<open>val lexicographicCompareBy : forall 'a. ('a -> 'a -> ordering) -> list 'a -> list 'a -> ordering\<close>\<close>

fun  lexicographicCompareBy  :: \<open>('a \<Rightarrow> 'a \<Rightarrow> ordering)\<Rightarrow> 'a list \<Rightarrow> 'a list \<Rightarrow> ordering \<close>  where 
     \<open> lexicographicCompareBy cmp ([]) ([]) = ( EQ )\<close> 
  for  "cmp"  :: " 'a \<Rightarrow> 'a \<Rightarrow> ordering "
|\<open> lexicographicCompareBy cmp ([]) (_ # _) = ( LT )\<close> 
  for  "cmp"  :: " 'a \<Rightarrow> 'a \<Rightarrow> ordering "
|\<open> lexicographicCompareBy cmp (_ # _) ([]) = ( GT )\<close> 
  for  "cmp"  :: " 'a \<Rightarrow> 'a \<Rightarrow> ordering "
|\<open> lexicographicCompareBy cmp (x # xs) (y # ys) = ( (
      (case  cmp x y of 
          LT => LT
        | GT => GT
        | EQ => lexicographicCompareBy cmp xs ys
      )
    ))\<close> 
  for  "cmp"  :: " 'a \<Rightarrow> 'a \<Rightarrow> ordering " 
  and  "xs"  :: " 'a list " 
  and  "x"  :: " 'a " 
  and  "ys"  :: " 'a list " 
  and  "y"  :: " 'a "


\<comment> \<open>\<open>val lexicographicLess : forall 'a. Ord 'a => list 'a -> list 'a -> bool\<close>\<close>
\<comment> \<open>\<open>val lexicographicLessBy : forall 'a. ('a -> 'a -> bool) -> ('a -> 'a -> bool) -> list 'a -> list 'a -> bool\<close>\<close>
fun  lexicographicLessBy  :: \<open>('a \<Rightarrow> 'a \<Rightarrow> bool)\<Rightarrow>('a \<Rightarrow> 'a \<Rightarrow> bool)\<Rightarrow> 'a list \<Rightarrow> 'a list \<Rightarrow> bool \<close>  where 
     \<open> lexicographicLessBy less1 less_eq1 ([]) ([]) = ( False )\<close> 
  for  "less1"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool " 
  and  "less_eq1"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool "
|\<open> lexicographicLessBy less1 less_eq1 ([]) (_ # _) = ( True )\<close> 
  for  "less1"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool " 
  and  "less_eq1"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool "
|\<open> lexicographicLessBy less1 less_eq1 (_ # _) ([]) = ( False )\<close> 
  for  "less1"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool " 
  and  "less_eq1"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool "
|\<open> lexicographicLessBy less1 less_eq1 (x # xs) (y # ys) = ( ((less1 x y) \<or> ((less_eq1 x y) \<and> (lexicographicLessBy less1 less_eq1 xs ys))))\<close> 
  for  "less1"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool " 
  and  "less_eq1"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool " 
  and  "xs"  :: " 'a list " 
  and  "x"  :: " 'a " 
  and  "ys"  :: " 'a list " 
  and  "y"  :: " 'a "


\<comment> \<open>\<open>val lexicographicLessEq : forall 'a. Ord 'a => list 'a -> list 'a -> bool\<close>\<close>
\<comment> \<open>\<open>val lexicographicLessEqBy : forall 'a. ('a -> 'a -> bool) -> ('a -> 'a -> bool) -> list 'a -> list 'a -> bool\<close>\<close>
fun  lexicographicLessEqBy  :: \<open>('a \<Rightarrow> 'a \<Rightarrow> bool)\<Rightarrow>('a \<Rightarrow> 'a \<Rightarrow> bool)\<Rightarrow> 'a list \<Rightarrow> 'a list \<Rightarrow> bool \<close>  where 
     \<open> lexicographicLessEqBy less1 less_eq1 ([]) ([]) = ( True )\<close> 
  for  "less1"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool " 
  and  "less_eq1"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool "
|\<open> lexicographicLessEqBy less1 less_eq1 ([]) (_ # _) = ( True )\<close> 
  for  "less1"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool " 
  and  "less_eq1"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool "
|\<open> lexicographicLessEqBy less1 less_eq1 (_ # _) ([]) = ( False )\<close> 
  for  "less1"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool " 
  and  "less_eq1"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool "
|\<open> lexicographicLessEqBy less1 less_eq1 (x # xs) (y # ys) = ( (less1 x y \<or> (less_eq1 x y \<and> lexicographicLessEqBy less1 less_eq1 xs ys)))\<close> 
  for  "less1"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool " 
  and  "less_eq1"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool " 
  and  "xs"  :: " 'a list " 
  and  "x"  :: " 'a " 
  and  "ys"  :: " 'a list " 
  and  "y"  :: " 'a "



definition instance_Basic_classes_Ord_list_dict  :: \<open> 'a Ord_class \<Rightarrow>('a list)Ord_class \<close>  where 
     \<open> instance_Basic_classes_Ord_list_dict dict_Basic_classes_Ord_a = ((|

  compare_method = (lexicographicCompareBy 
  (compare_method   dict_Basic_classes_Ord_a)),

  isLess_method = (lexicographicLessBy 
  (isLess_method   dict_Basic_classes_Ord_a) (isLessEqual_method   dict_Basic_classes_Ord_a)),

  isLessEqual_method = (lexicographicLessEqBy 
  (isLess_method   dict_Basic_classes_Ord_a) (isLessEqual_method   dict_Basic_classes_Ord_a)),

  isGreater_method = ((\<lambda> x y. (lexicographicLessBy 
  (isLess_method   dict_Basic_classes_Ord_a) (isLessEqual_method   dict_Basic_classes_Ord_a) y x))),

  isGreaterEqual_method = ((\<lambda> x y. (lexicographicLessEqBy 
  (isLess_method   dict_Basic_classes_Ord_a) (isLessEqual_method   dict_Basic_classes_Ord_a) y x)))|) )\<close> 
  for  "dict_Basic_classes_Ord_a"  :: " 'a Ord_class "



\<comment> \<open>\<open> ----------------------- \<close>\<close>
\<comment> \<open>\<open> Append                  \<close>\<close>
\<comment> \<open>\<open> ----------------------- \<close>\<close>

\<comment> \<open>\<open>val ++ : forall 'a. list 'a -> list 'a -> list 'a\<close>\<close> \<comment> \<open>\<open> originally append \<close>\<close>
\<comment> \<open>\<open>let rec ++ xs ys=  match xs with
                     | [] -> ys
                     | x :: xs' -> x :: (xs' ++ ys)
                   end\<close>\<close>

\<comment> \<open>\<open> ----------------------- \<close>\<close>
\<comment> \<open>\<open> snoc                    \<close>\<close>
\<comment> \<open>\<open> ----------------------- \<close>\<close>

\<comment> \<open>\<open>val snoc : forall 'a. 'a -> list 'a -> list 'a\<close>\<close>
\<comment> \<open>\<open>let snoc e l=  l ++ [e]\<close>\<close>


\<comment> \<open>\<open> ----------------------- \<close>\<close>
\<comment> \<open>\<open> Reverse                 \<close>\<close>
\<comment> \<open>\<open> ----------------------- \<close>\<close>

\<comment> \<open>\<open> First lets define the function [reverse_append], which is
   closely related to reverse. [reverse_append l1 l2] appends the list [l2] to the reverse of [l1].
   This can be implemented more efficienctly than appending and is
   used to implement reverse. \<close>\<close>

\<comment> \<open>\<open>val reverseAppend : forall 'a. list 'a -> list 'a -> list 'a\<close>\<close> \<comment> \<open>\<open> originally named rev_append \<close>\<close>
\<comment> \<open>\<open>let rec reverseAppend l1 l2=  match l1 with 
                                | [] -> l2
                                | x :: xs -> reverseAppend xs (x :: l2)
                               end\<close>\<close>

\<comment> \<open>\<open> Reversing a list \<close>\<close>
\<comment> \<open>\<open>val reverse : forall 'a. list 'a -> list 'a\<close>\<close> \<comment> \<open>\<open> originally named rev \<close>\<close>
\<comment> \<open>\<open>let reverse l=  reverseAppend l []\<close>\<close>

\<comment> \<open>\<open> ----------------------- \<close>\<close>
\<comment> \<open>\<open> Map                     \<close>\<close>
\<comment> \<open>\<open> ----------------------- \<close>\<close>

\<comment> \<open>\<open>val map_tr : forall 'a 'b. list 'b -> ('a -> 'b) -> list 'a -> list 'b\<close>\<close>
function (sequential,domintros)  map_tr  :: \<open> 'b list \<Rightarrow>('a \<Rightarrow> 'b)\<Rightarrow> 'a list \<Rightarrow> 'b list \<close>  where 
     \<open> map_tr rev_acc f ([]) = ( List.rev rev_acc )\<close> 
  for  "rev_acc"  :: " 'b list " 
  and  "f"  :: " 'a \<Rightarrow> 'b "
|\<open> map_tr rev_acc f (x # xs) = ( map_tr ((f x) # rev_acc) f xs )\<close> 
  for  "rev_acc"  :: " 'b list " 
  and  "f"  :: " 'a \<Rightarrow> 'b " 
  and  "xs"  :: " 'a list " 
  and  "x"  :: " 'a " 
by pat_completeness auto


\<comment> \<open>\<open> taken from: https://blogs.janestreet.com/optimizing-list-map/ \<close>\<close>
\<comment> \<open>\<open>val count_map : forall 'a 'b. ('a -> 'b) -> list 'a -> nat -> list 'b\<close>\<close>
function (sequential,domintros)  count_map  :: \<open>('a \<Rightarrow> 'b)\<Rightarrow> 'a list \<Rightarrow> nat \<Rightarrow> 'b list \<close>  where 
     \<open> count_map f ([]) ctr = ( [])\<close> 
  for  "f"  :: " 'a \<Rightarrow> 'b " 
  and  "ctr"  :: " nat "
|\<open> count_map f (hd1 # tl1) ctr = ( f hd1 # 
    (if ctr <( 5000 :: nat) then count_map f tl1 (ctr +( 1 :: nat)) 
    else map_tr [] f tl1))\<close> 
  for  "f"  :: " 'a \<Rightarrow> 'b " 
  and  "tl1"  :: " 'a list " 
  and  "hd1"  :: " 'a " 
  and  "ctr"  :: " nat " 
by pat_completeness auto

 
\<comment> \<open>\<open>val map : forall 'a 'b. ('a -> 'b) -> list 'a -> list 'b\<close>\<close>
\<comment> \<open>\<open>let map f l=  count_map f l 0\<close>\<close>

\<comment> \<open>\<open> ----------------------- \<close>\<close>
\<comment> \<open>\<open> Reverse Map             \<close>\<close>
\<comment> \<open>\<open> ----------------------- \<close>\<close>

\<comment> \<open>\<open>val reverseMap : forall 'a 'b. ('a -> 'b) -> list 'a -> list 'b\<close>\<close>


\<comment> \<open>\<open> ========================================================================== \<close>\<close>
\<comment> \<open>\<open> Folding                                                                    \<close>\<close>
\<comment> \<open>\<open> ========================================================================== \<close>\<close>

\<comment> \<open>\<open> ----------------------- \<close>\<close>
\<comment> \<open>\<open> fold left               \<close>\<close>
\<comment> \<open>\<open> ----------------------- \<close>\<close>

\<comment> \<open>\<open>val foldl : forall 'a 'b. ('a -> 'b -> 'a) -> 'a -> list 'b -> 'a\<close>\<close> \<comment> \<open>\<open> originally foldl \<close>\<close>

\<comment> \<open>\<open>let rec foldl f b l=  match l with
  | []      -> b
  | x :: xs -> foldl f (f b x) xs
end\<close>\<close>


\<comment> \<open>\<open> ----------------------- \<close>\<close>
\<comment> \<open>\<open> fold right              \<close>\<close>
\<comment> \<open>\<open> ----------------------- \<close>\<close>

\<comment> \<open>\<open>val foldr : forall 'a 'b. ('a -> 'b -> 'b) -> 'b -> list 'a -> 'b\<close>\<close> \<comment> \<open>\<open> originally foldr with different argument order \<close>\<close>
\<comment> \<open>\<open>let rec foldr f b l=  match l with
  | []      -> b
  | x :: xs -> f x (foldr f b xs)
end\<close>\<close>


\<comment> \<open>\<open> ----------------------- \<close>\<close>
\<comment> \<open>\<open> concatenating lists     \<close>\<close>
\<comment> \<open>\<open> ----------------------- \<close>\<close>

\<comment> \<open>\<open>val concat : forall 'a. list (list 'a) -> list 'a\<close>\<close> \<comment> \<open>\<open> before also called "flatten" \<close>\<close>
\<comment> \<open>\<open>let concat=  foldr (++) []\<close>\<close>


\<comment> \<open>\<open> -------------------------- \<close>\<close>
\<comment> \<open>\<open> concatenating with mapping \<close>\<close>
\<comment> \<open>\<open> -------------------------- \<close>\<close>

\<comment> \<open>\<open>val concatMap : forall 'a 'b. ('a -> list 'b) -> list 'a -> list 'b\<close>\<close>


\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> universal qualification   \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>

\<comment> \<open>\<open>val all : forall 'a. ('a -> bool) -> list 'a -> bool\<close>\<close> \<comment> \<open>\<open> originally for_all \<close>\<close>
\<comment> \<open>\<open>let all P l=  foldl (fun r e -> P e && r) true l\<close>\<close>



\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> existential qualification \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>

\<comment> \<open>\<open>val any : forall 'a. ('a -> bool) -> list 'a -> bool\<close>\<close> \<comment> \<open>\<open> originally exist \<close>\<close>
\<comment> \<open>\<open>let any P l=  foldl (fun r e -> P e || r) false l\<close>\<close>


\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> dest_init                 \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>

\<comment> \<open>\<open> get the initial part and the last element of the list in a safe way \<close>\<close>

\<comment> \<open>\<open>val dest_init : forall 'a. list 'a -> maybe (list 'a * 'a)\<close>\<close> 

fun  dest_init_aux  :: \<open> 'a list \<Rightarrow> 'a \<Rightarrow> 'a list \<Rightarrow> 'a list*'a \<close>  where 
     \<open> dest_init_aux rev_init last_elem_seen ([]) = ( (List.rev rev_init, last_elem_seen))\<close> 
  for  "rev_init"  :: " 'a list " 
  and  "last_elem_seen"  :: " 'a "
|\<open> dest_init_aux rev_init last_elem_seen (x # xs) = ( dest_init_aux (last_elem_seen # rev_init) x xs )\<close> 
  for  "rev_init"  :: " 'a list " 
  and  "last_elem_seen"  :: " 'a " 
  and  "xs"  :: " 'a list " 
  and  "x"  :: " 'a "


fun dest_init  :: \<open> 'a list \<Rightarrow>('a list*'a)option \<close>  where 
     \<open> dest_init ([]) = ( None )\<close>
|\<open> dest_init (x # xs) = ( Some (dest_init_aux [] x xs))\<close> 
  for  "xs"  :: " 'a list " 
  and  "x"  :: " 'a "



\<comment> \<open>\<open> ========================================================================== \<close>\<close>
\<comment> \<open>\<open> Indexing lists                                                             \<close>\<close>
\<comment> \<open>\<open> ========================================================================== \<close>\<close>

\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> index / nth with maybe   \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>

\<comment> \<open>\<open>val index : forall 'a. list 'a -> nat -> maybe 'a\<close>\<close>

\<comment> \<open>\<open>let rec index l n=  match l with 
  | []      -> Nothing
  | x :: xs -> if (Instance_Basic_classes_Eq_nat.=) n 0 then Just x else index xs ((Instance_Num_NumMinus_nat.-)n 1)
end\<close>\<close>

\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> findIndices               \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>

\<comment> \<open>\<open> [findIndices P l] returns the indices of all elements of list [l] that satisfy predicate [P]. 
   Counting starts with 0, the result list is sorted ascendingly \<close>\<close>
\<comment> \<open>\<open>val findIndices : forall 'a. ('a -> bool) -> list 'a -> list nat\<close>\<close>

fun  findIndices_aux  :: \<open> nat \<Rightarrow>('a \<Rightarrow> bool)\<Rightarrow> 'a list \<Rightarrow>(nat)list \<close>  where 
     \<open> findIndices_aux (i::nat) P ([]) = ( [])\<close> 
  for  "i"  :: " nat " 
  and  "P"  :: " 'a \<Rightarrow> bool "
|\<open> findIndices_aux (i::nat) P (x # xs) = ( if P x then i # findIndices_aux (i +( 1 :: nat)) P xs else findIndices_aux (i +( 1 :: nat)) P xs )\<close> 
  for  "i"  :: " nat " 
  and  "P"  :: " 'a \<Rightarrow> bool " 
  and  "xs"  :: " 'a list " 
  and  "x"  :: " 'a "

\<comment> \<open>\<open>let findIndices P l=  findIndices_aux 0 P l\<close>\<close>



\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> findIndex                 \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>

\<comment> \<open>\<open> findIndex returns the first index of a list that satisfies a given predicate. \<close>\<close>
\<comment> \<open>\<open>val findIndex : forall 'a. ('a -> bool) -> list 'a -> maybe nat\<close>\<close>
\<comment> \<open>\<open>let findIndex P l=  match findIndices P l with
  | [] -> Nothing
  | x :: _ -> Just x
end\<close>\<close>

\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> elemIndices               \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>

\<comment> \<open>\<open>val elemIndices : forall 'a. Eq 'a => 'a -> list 'a -> list nat\<close>\<close>

\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> elemIndex                 \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>

\<comment> \<open>\<open>val elemIndex : forall 'a. Eq 'a => 'a -> list 'a -> maybe nat\<close>\<close>


\<comment> \<open>\<open> ========================================================================== \<close>\<close>
\<comment> \<open>\<open> Creating lists                                                             \<close>\<close>
\<comment> \<open>\<open> ========================================================================== \<close>\<close>

\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> genlist                   \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>

\<comment> \<open>\<open> [genlist f n] generates the list [f 1; ... (f (n-1))] \<close>\<close>
\<comment> \<open>\<open>val genlist : forall 'a. (nat -> 'a) -> nat -> list 'a\<close>\<close>


\<comment> \<open>\<open>let rec genlist f (n : nat)=
   match (n : nat) with
    | (0:nat) -> []
    | n' + 1 -> snoc (f n') (genlist f n')
  end\<close>\<close>


\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> replicate                 \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>

\<comment> \<open>\<open>val replicate : forall 'a. nat -> 'a -> list 'a\<close>\<close>
\<comment> \<open>\<open>let rec replicate n x=
   match n with
    | 0 -> []
    | n' + 1 -> x :: replicate n' x
  end\<close>\<close>


\<comment> \<open>\<open> ========================================================================== \<close>\<close>
\<comment> \<open>\<open> Sublists                                                                   \<close>\<close>
\<comment> \<open>\<open> ========================================================================== \<close>\<close>

\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> splitAt                   \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>

\<comment> \<open>\<open> [splitAt n xs] returns a tuple (xs1, xs2), with "append xs1 xs2 = xs" and 
   "length xs1 = n". If there are not enough elements 
   in [xs], the original list and the empty one are returned. \<close>\<close>
\<comment> \<open>\<open>val splitAtAcc : forall 'a. list 'a -> nat -> list 'a -> (list 'a * list 'a)\<close>\<close>
function (sequential,domintros)  splitAtAcc  :: \<open> 'a list \<Rightarrow> nat \<Rightarrow> 'a list \<Rightarrow> 'a list*'a list \<close>  where 
     \<open> splitAtAcc revAcc n l = ( 
  (case  l of
      []    => (List.rev revAcc, [])
    | x # xs => if n \<le>( 0 :: nat) then (List.rev revAcc, l) else splitAtAcc (x # revAcc) (n-( 1 :: nat)) xs
  ))\<close> 
  for  "revAcc"  :: " 'a list " 
  and  "n"  :: " nat " 
  and  "l"  :: " 'a list " 
by pat_completeness auto


\<comment> \<open>\<open>val splitAt : forall 'a. nat -> list 'a -> (list 'a * list 'a)\<close>\<close>
\<comment> \<open>\<open>let rec splitAt n l= 
    splitAtAcc [] n l\<close>\<close>


\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> take                      \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>

\<comment> \<open>\<open> take n xs returns the prefix of xs of length n, or xs itself if n > length xs \<close>\<close>
\<comment> \<open>\<open>val take : forall 'a. nat -> list 'a -> list 'a\<close>\<close>
\<comment> \<open>\<open>let take n l=  fst (splitAt n l)\<close>\<close>

\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> drop                      \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>

\<comment> \<open>\<open> [drop n xs] drops the first [n] elements of [xs]. It returns the empty list, if [n] > [length xs]. \<close>\<close>
\<comment> \<open>\<open>val drop : forall 'a. nat -> list 'a -> list 'a\<close>\<close>
\<comment> \<open>\<open>let drop n l=  snd (splitAt n l)\<close>\<close>

\<comment> \<open>\<open> ------------------------------------ \<close>\<close>
\<comment> \<open>\<open> splitWhile, takeWhile, and dropWhile \<close>\<close>
\<comment> \<open>\<open> ------------------------------------ \<close>\<close>

\<comment> \<open>\<open>val splitWhile_tr : forall 'a. ('a -> bool) -> list 'a -> list 'a -> (list 'a * list 'a)\<close>\<close>
fun  splitWhile_tr  :: \<open>('a \<Rightarrow> bool)\<Rightarrow> 'a list \<Rightarrow> 'a list \<Rightarrow> 'a list*'a list \<close>  where 
     \<open> splitWhile_tr p ([]) acc1 = (
    (List.rev acc1, []))\<close> 
  for  "p"  :: " 'a \<Rightarrow> bool " 
  and  "acc1"  :: " 'a list "
|\<open> splitWhile_tr p (x # xs) acc1 = (
    if p x then
      splitWhile_tr p xs (x # acc1)
    else
      (List.rev acc1, (x # xs)))\<close> 
  for  "p"  :: " 'a \<Rightarrow> bool " 
  and  "xs"  :: " 'a list " 
  and  "x"  :: " 'a " 
  and  "acc1"  :: " 'a list "


\<comment> \<open>\<open>val splitWhile : forall 'a. ('a -> bool) -> list 'a -> (list 'a * list 'a)\<close>\<close>
definition splitWhile  :: \<open>('a \<Rightarrow> bool)\<Rightarrow> 'a list \<Rightarrow> 'a list*'a list \<close>  where 
     \<open> splitWhile p xs = ( splitWhile_tr p xs [])\<close> 
  for  "p"  :: " 'a \<Rightarrow> bool " 
  and  "xs"  :: " 'a list "


\<comment> \<open>\<open> [takeWhile p xs] takes the first elements of [xs] that satisfy [p]. \<close>\<close>
\<comment> \<open>\<open>val takeWhile : forall 'a. ('a -> bool) -> list 'a -> list 'a\<close>\<close>
definition takeWhile  :: \<open>('a \<Rightarrow> bool)\<Rightarrow> 'a list \<Rightarrow> 'a list \<close>  where 
     \<open> takeWhile p l = ( fst (splitWhile p l))\<close> 
  for  "p"  :: " 'a \<Rightarrow> bool " 
  and  "l"  :: " 'a list "


\<comment> \<open>\<open> [dropWhile p xs] drops the first elements of [xs] that satisfy [p]. \<close>\<close>
\<comment> \<open>\<open>val dropWhile : forall 'a. ('a -> bool) -> list 'a -> list 'a\<close>\<close>
definition dropWhile  :: \<open>('a \<Rightarrow> bool)\<Rightarrow> 'a list \<Rightarrow> 'a list \<close>  where 
     \<open> dropWhile p l = ( snd (splitWhile p l))\<close> 
  for  "p"  :: " 'a \<Rightarrow> bool " 
  and  "l"  :: " 'a list "


\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> isPrefixOf                \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>

\<comment> \<open>\<open>val isPrefixOf : forall 'a. Eq 'a => list 'a -> list 'a -> bool\<close>\<close>
fun  isPrefixOf  :: \<open> 'a list \<Rightarrow> 'a list \<Rightarrow> bool \<close>  where 
     \<open> isPrefixOf ([]) _ = ( True )\<close>
|\<open> isPrefixOf (_ # _) ([]) = ( False )\<close>
|\<open> isPrefixOf (x # xs) (y # ys) = ( (x = y) \<and> isPrefixOf xs ys )\<close> 
  for  "xs"  :: " 'a list " 
  and  "x"  :: " 'a " 
  and  "ys"  :: " 'a list " 
  and  "y"  :: " 'a "


\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> update                    \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open>val update : forall 'a. list 'a -> nat -> 'a -> list 'a\<close>\<close>
\<comment> \<open>\<open>let rec update l n e= 
   match l with
    | []      -> []
    | x :: xs -> if (Instance_Basic_classes_Eq_nat.=) n 0 then e :: xs else x :: (update xs ((Instance_Num_NumMinus_nat.-) n 1) e)
end\<close>\<close>



\<comment> \<open>\<open> ========================================================================== \<close>\<close>
\<comment> \<open>\<open> Searching lists                                                            \<close>\<close>
\<comment> \<open>\<open> ========================================================================== \<close>\<close>

\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> Membership test           \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>

\<comment> \<open>\<open> The membership test, one of the basic list functions, is actually tricky for
   Lem, because it is tricky, which equality to use. From Lem`s point of 
   perspective, we want to use the equality provided by the equality type - class.
   This allows for example to check whether a set is in a list of sets.

   However, in order to use the equality type class, elem essentially becomes
   existential quantification over lists. For types, which implement semantic
   equality (=) with syntactic equality, this is overly complicated. In
   our theorem prover backend, we would end up with overly complicated, harder
   to read definitions and some of the automation would be harder to apply.
   Moreover, nearly all the old Lem generated code would change and require 
   (hopefully minor) adaptions of proofs.

   For now, we ignore this problem and just demand, that all instances of
   the equality type class do the right thing for the theorem prover backends.   
\<close>\<close>

\<comment> \<open>\<open>val elem : forall 'a. Eq 'a => 'a -> list 'a -> bool\<close>\<close>
\<comment> \<open>\<open>val elemBy : forall 'a. ('a -> 'a -> bool) -> 'a -> list 'a -> bool\<close>\<close>

definition elemBy  :: \<open>('a \<Rightarrow> 'a \<Rightarrow> bool)\<Rightarrow> 'a \<Rightarrow> 'a list \<Rightarrow> bool \<close>  where 
     \<open> elemBy eq e l = ( ((\<exists> x \<in> (set l).  (eq e) x)))\<close> 
  for  "eq"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool " 
  and  "e"  :: " 'a " 
  and  "l"  :: " 'a list "

\<comment> \<open>\<open>let elem=  elemBy (=)\<close>\<close>

\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> Find                      \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open>val find : forall 'a. ('a -> bool) -> list 'a -> maybe 'a\<close>\<close> \<comment> \<open>\<open> previously not of maybe type \<close>\<close>
\<comment> \<open>\<open>let rec find P l=  match l with 
  | []      -> Nothing
  | x :: xs -> if P x then Just x else find P xs
end\<close>\<close>


\<comment> \<open>\<open> ----------------------------- \<close>\<close>
\<comment> \<open>\<open> Lookup in an associative list \<close>\<close>
\<comment> \<open>\<open> ----------------------------- \<close>\<close>
\<comment> \<open>\<open>val lookup   : forall 'a 'b. Eq 'a              => 'a -> list ('a * 'b) -> maybe 'b\<close>\<close>
\<comment> \<open>\<open>val lookupBy : forall 'a 'b. ('a -> 'a -> bool) -> 'a -> list ('a * 'b) -> maybe 'b\<close>\<close>

\<comment> \<open>\<open> DPM: eta-expansion for Coq backend type-inference. \<close>\<close>
definition lookupBy  :: \<open>('a \<Rightarrow> 'a \<Rightarrow> bool)\<Rightarrow> 'a \<Rightarrow>('a*'b)list \<Rightarrow> 'b option \<close>  where 
     \<open> lookupBy eq k m = ( map_option ((\<lambda> x .  snd x)) (List.find ( (\<lambda>x .  
  (case  x of (k', _) => eq k k' ))) m))\<close> 
  for  "eq"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool " 
  and  "k"  :: " 'a " 
  and  "m"  :: "('a*'b)list "


\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> filter                    \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open>val filter : forall 'a. ('a -> bool) -> list 'a -> list 'a\<close>\<close>
\<comment> \<open>\<open>let rec filter P l=  match l with
                       | [] -> []
                       | x :: xs -> if (P x) then x :: (filter P xs) else filter P xs
                     end\<close>\<close>


\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> partition                 \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open>val partition : forall 'a. ('a -> bool) -> list 'a -> list 'a * list 'a\<close>\<close>
\<comment> \<open>\<open>let partition P l=  (filter P l, filter (fun x -> not (P x)) l)\<close>\<close>

\<comment> \<open>\<open>val reversePartition : forall 'a. ('a -> bool) -> list 'a -> list 'a * list 'a\<close>\<close>
definition reversePartition  :: \<open>('a \<Rightarrow> bool)\<Rightarrow> 'a list \<Rightarrow> 'a list*'a list \<close>  where 
     \<open> reversePartition P l = ( List.partition P (List.rev l))\<close> 
  for  "P"  :: " 'a \<Rightarrow> bool " 
  and  "l"  :: " 'a list "



\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> delete first element      \<close>\<close>
\<comment> \<open>\<open> with certain property     \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>

\<comment> \<open>\<open>val deleteFirst : forall 'a. ('a -> bool) -> list 'a -> maybe (list 'a)\<close>\<close> 
\<comment> \<open>\<open>let rec deleteFirst P l=  match l with
                            | [] -> Nothing
                            | x :: xs -> if (P x) then Just xs else Maybe.map (fun xs' -> x :: xs') (deleteFirst P xs)
                          end\<close>\<close>


\<comment> \<open>\<open>val delete : forall 'a. Eq 'a => 'a -> list 'a -> list 'a\<close>\<close>
\<comment> \<open>\<open>val deleteBy : forall 'a. ('a -> 'a -> bool) -> 'a -> list 'a -> list 'a\<close>\<close>

definition deleteBy  :: \<open>('a \<Rightarrow> 'a \<Rightarrow> bool)\<Rightarrow> 'a \<Rightarrow> 'a list \<Rightarrow> 'a list \<close>  where 
     \<open> deleteBy eq x l = ( case_option l id (delete_first (eq x) l))\<close> 
  for  "eq"  :: " 'a \<Rightarrow> 'a \<Rightarrow> bool " 
  and  "x"  :: " 'a " 
  and  "l"  :: " 'a list "



\<comment> \<open>\<open> ========================================================================== \<close>\<close>
\<comment> \<open>\<open> Zipping and unzipping lists                                                \<close>\<close>
\<comment> \<open>\<open> ========================================================================== \<close>\<close>

\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> zip                       \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>

\<comment> \<open>\<open> zip takes two lists and returns a list of corresponding pairs. If one input list is short, excess elements of the longer list are discarded. \<close>\<close>
\<comment> \<open>\<open>val zip : forall 'a 'b. list 'a -> list 'b -> list ('a * 'b)\<close>\<close> \<comment> \<open>\<open> before combine \<close>\<close>
\<comment> \<open>\<open>let rec zip l1 l2=  match (l1, l2) with
  | (x :: xs, y :: ys) -> (x, y) :: zip xs ys
  | _ -> []
end\<close>\<close>

\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> unzip                     \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>

\<comment> \<open>\<open>val unzip: forall 'a 'b. list ('a * 'b) -> (list 'a * list 'b)\<close>\<close>
\<comment> \<open>\<open>let rec unzip l=  match l with
  | [] -> ([], [])
  | (x, y) :: xys -> let (xs, ys) = unzip xys in (x :: xs, y :: ys)
end\<close>\<close>

\<comment> \<open>\<open> ------------------------- \<close>\<close>
\<comment> \<open>\<open> distinct elements         \<close>\<close>
\<comment> \<open>\<open> ------------------------- \<close>\<close>

\<comment> \<open>\<open>val allDistinct : forall 'a. Eq 'a => list 'a -> bool\<close>\<close>
fun  allDistinct  :: \<open> 'a list \<Rightarrow> bool \<close>  where 
     \<open> allDistinct ([]) = ( True )\<close>
|\<open> allDistinct (x # l') = ( \<not> (Set.member x (set l')) \<and> allDistinct l' )\<close> 
  for  "l'"  :: " 'a list " 
  and  "x"  :: " 'a "


\<comment> \<open>\<open> some more useful functions \<close>\<close>
\<comment> \<open>\<open>val mapMaybe : forall 'a 'b. ('a -> maybe 'b) -> list 'a -> list 'b\<close>\<close>
function (sequential,domintros)  mapMaybe  :: \<open>('a \<Rightarrow> 'b option)\<Rightarrow> 'a list \<Rightarrow> 'b list \<close>  where 
     \<open> mapMaybe f ([]) = ( [])\<close> 
  for  "f"  :: " 'a \<Rightarrow> 'b option "
|\<open> mapMaybe f (x # xs) = (
      (case  f x of
        None => mapMaybe f xs
      | Some y => y # (mapMaybe f xs)
      ))\<close> 
  for  "f"  :: " 'a \<Rightarrow> 'b option " 
  and  "xs"  :: " 'a list " 
  and  "x"  :: " 'a " 
by pat_completeness auto


\<comment> \<open>\<open>val mapi : forall 'a 'b. (nat -> 'a -> 'b) -> list 'a -> list 'b\<close>\<close>
function (sequential,domintros)  mapiAux  :: \<open>(nat \<Rightarrow> 'b \<Rightarrow> 'a)\<Rightarrow> nat \<Rightarrow> 'b list \<Rightarrow> 'a list \<close>  where 
     \<open> mapiAux f (n :: nat) ([]) = ( [])\<close> 
  for  "f"  :: " nat \<Rightarrow> 'b \<Rightarrow> 'a " 
  and  "n"  :: " nat "
|\<open> mapiAux f (n :: nat) (x # xs) = ( (f n x) # mapiAux f (n +( 1 :: nat)) xs )\<close> 
  for  "f"  :: " nat \<Rightarrow> 'b \<Rightarrow> 'a " 
  and  "n"  :: " nat " 
  and  "xs"  :: " 'b list " 
  and  "x"  :: " 'b " 
by pat_completeness auto

definition mapi  :: \<open>(nat \<Rightarrow> 'a \<Rightarrow> 'b)\<Rightarrow> 'a list \<Rightarrow> 'b list \<close>  where 
     \<open> mapi f l = ( mapiAux f(( 0 :: nat)) l )\<close> 
  for  "f"  :: " nat \<Rightarrow> 'a \<Rightarrow> 'b " 
  and  "l"  :: " 'a list "


\<comment> \<open>\<open>val deletes: forall 'a. Eq 'a => list 'a -> list 'a -> list 'a\<close>\<close>
definition deletes  :: \<open> 'a list \<Rightarrow> 'a list \<Rightarrow> 'a list \<close>  where 
     \<open> deletes xs ys = (
  List.foldl (((\<lambda> x y. remove1 y x))) xs ys )\<close> 
  for  "xs"  :: " 'a list " 
  and  "ys"  :: " 'a list "


\<comment> \<open>\<open> ========================================================================== \<close>\<close>
\<comment> \<open>\<open> Comments (not clean yet, please ignore the rest of the file)               \<close>\<close>
\<comment> \<open>\<open> ========================================================================== \<close>\<close>

\<comment> \<open>\<open> ----------------------- \<close>\<close>
\<comment> \<open>\<open> skipped from Haskell Lib\<close>\<close>
\<comment> \<open>\<open> ----------------------- 

intersperse :: a -> [a] -> [a]
intercalate :: [a] -> [[a]] -> [a]
transpose :: [[a]] -> [[a]]
subsequences :: [a] -> [[a]]
permutations :: [a] -> [[a]]
foldl` :: (a -> b -> a) -> a -> [b] -> aSource
foldl1` :: (a -> a -> a) -> [a] -> aSource

and
or
sum
product
maximum
minimum
scanl
scanr
scanl1
scanr1
Accumulating maps

mapAccumL :: (acc -> x -> (acc, y)) -> acc -> [x] -> (acc, [y])Source
mapAccumR :: (acc -> x -> (acc, y)) -> acc -> [x] -> (acc, [y])Source

iterate :: (a -> a) -> a -> [a]
repeat :: a -> [a]
cycle :: [a] -> [a]
unfoldr


takeWhile :: (a -> Bool) -> [a] -> [a]Source
dropWhile :: (a -> Bool) -> [a] -> [a]Source
dropWhileEnd :: (a -> Bool) -> [a] -> [a]Source
span :: (a -> Bool) -> [a] -> ([a], [a])Source
break :: (a -> Bool) -> [a] -> ([a], [a])Source
break p is equivalent to span (not . p).
stripPrefix :: Eq a => [a] -> [a] -> Maybe [a]Source
group :: Eq a => [a] -> [[a]]Source
inits :: [a] -> [[a]]Source
tails :: [a] -> [[a]]Source


isPrefixOf :: Eq a => [a] -> [a] -> BoolSource
isSuffixOf :: Eq a => [a] -> [a] -> BoolSource
isInfixOf :: Eq a => [a] -> [a] -> BoolSource



notElem :: Eq a => a -> [a] -> BoolSource

zip3 :: [a] -> [b] -> [c] -> [(a, b, c)]Source
zip4 :: [a] -> [b] -> [c] -> [d] -> [(a, b, c, d)]Source
zip5 :: [a] -> [b] -> [c] -> [d] -> [e] -> [(a, b, c, d, e)]Source
zip6 :: [a] -> [b] -> [c] -> [d] -> [e] -> [f] -> [(a, b, c, d, e, f)]Source
zip7 :: [a] -> [b] -> [c] -> [d] -> [e] -> [f] -> [g] -> [(a, b, c, d, e, f, g)]Source

zipWith :: (a -> b -> c) -> [a] -> [b] -> [c]Source
zipWith3 :: (a -> b -> c -> d) -> [a] -> [b] -> [c] -> [d]Source
zipWith4 :: (a -> b -> c -> d -> e) -> [a] -> [b] -> [c] -> [d] -> [e]Source
zipWith5 :: (a -> b -> c -> d -> e -> f) -> [a] -> [b] -> [c] -> [d] -> [e] -> [f]Source
zipWith6 :: (a -> b -> c -> d -> e -> f -> g) -> [a] -> [b] -> [c] -> [d] -> [e] -> [f] -> [g]Source
zipWith7 :: (a -> b -> c -> d -> e -> f -> g -> h) -> [a] -> [b] -> [c] -> [d] -> [e] -> [f] -> [g] -> [h]Source


unzip3 :: [(a, b, c)] -> ([a], [b], [c])Source
unzip4 :: [(a, b, c, d)] -> ([a], [b], [c], [d])Source
unzip5 :: [(a, b, c, d, e)] -> ([a], [b], [c], [d], [e])Source
unzip6 :: [(a, b, c, d, e, f)] -> ([a], [b], [c], [d], [e], [f])Source
unzip7 :: [(a, b, c, d, e, f, g)] -> ([a], [b], [c], [d], [e], [f], [g])Source


lines :: String -> [String]Source
words :: String -> [String]Source
unlines :: [String] -> StringSource
unwords :: [String] -> StringSource
nub :: Eq a => [a] -> [a]Source
delete :: Eq a => a -> [a] -> [a]Source

(\\) :: Eq a => [a] -> [a] -> [a]Source
union :: Eq a => [a] -> [a] -> [a]Source
intersect :: Eq a => [a] -> [a] -> [a]Source
sort :: Ord a => [a] -> [a]Source
insert :: Ord a => a -> [a] -> [a]Source


nubBy :: (a -> a -> Bool) -> [a] -> [a]Source
deleteBy :: (a -> a -> Bool) -> a -> [a] -> [a]Source
deleteFirstsBy :: (a -> a -> Bool) -> [a] -> [a] -> [a]Source
unionBy :: (a -> a -> Bool) -> [a] -> [a] -> [a]Source
intersectBy :: (a -> a -> Bool) -> [a] -> [a] -> [a]Source
groupBy :: (a -> a -> Bool) -> [a] -> [[a]]Source
sortBy :: (a -> a -> Ordering) -> [a] -> [a]Source
insertBy :: (a -> a -> Ordering) -> a -> [a] -> [a]Source
maximumBy :: (a -> a -> Ordering) -> [a] -> aSource
minimumBy :: (a -> a -> Ordering) -> [a] -> aSource
genericLength :: Num i => [b] -> iSource
genericTake :: Integral i => i -> [a] -> [a]Source
genericDrop :: Integral i => i -> [a] -> [a]Source
genericSplitAt :: Integral i => i -> [b] -> ([b], [b])Source
genericIndex :: Integral a => [b] -> a -> bSource
genericReplicate :: Integral i => i -> a -> [a]Source


\<close>\<close>


\<comment> \<open>\<open> ----------------------- \<close>\<close>
\<comment> \<open>\<open> skipped from Lem Lib    \<close>\<close>
\<comment> \<open>\<open> ----------------------- 


val for_all2 : forall 'a 'b. ('a -> 'b -> bool) -> list 'a -> list 'b -> bool
val exists2 : forall 'a 'b. ('a -> 'b -> bool) -> list 'a -> list 'b -> bool
val map2 : forall 'a 'b 'c. ('a -> 'b -> 'c) -> list 'a -> list 'b -> list 'c 
val rev_map2 : forall 'a 'b 'c. ('a -> 'b -> 'c) -> list 'a -> list 'b -> list 'c
val fold_left2 : forall 'a 'b 'c. ('a -> 'b -> 'c -> 'a) -> 'a -> list 'b -> list 'c -> 'a
val fold_right2 : forall 'a 'b 'c. ('a -> 'b -> 'c -> 'c) -> list 'a -> list 'b -> 'c -> 'c


\<open> now maybe result and called lookup \<close>
val assoc : forall 'a 'b. 'a -> list ('a * 'b) -> 'b
let inline {ocaml} assoc = Ocaml.List.assoc


val mem_assoc : forall 'a 'b. 'a -> list ('a * 'b) -> bool
val remove_assoc : forall 'a 'b. 'a -> list ('a * 'b) -> list ('a * 'b)



val stable_sort : forall 'a. ('a -> 'a -> num) -> list 'a -> list 'a
val fast_sort : forall 'a. ('a -> 'a -> num) -> list 'a -> list 'a

val merge : forall 'a. ('a -> 'a -> num) -> list 'a -> list 'a -> list 'a
val intersect : forall 'a. list 'a -> list 'a -> list 'a


\<close>\<close>

\<comment> \<open>\<open>val     catMaybes : forall 'a. list (maybe 'a) -> list 'a\<close>\<close>
function (sequential,domintros)  catMaybes  :: \<open>('a option)list \<Rightarrow> 'a list \<close>  where 
     \<open> catMaybes ([]) = (
        [])\<close>
|\<open> catMaybes (None # xs') = (
        catMaybes xs' )\<close> 
  for  "xs'"  :: "('a option)list "
|\<open> catMaybes (Some x # xs') = (
        x # catMaybes xs' )\<close> 
  for  "xs'"  :: "('a option)list " 
  and  "x"  :: " 'a " 
by pat_completeness auto

end
